leetcode 2466.统计构造好字符串的方案数

思路:dp

其实这道题总的来说,就是爬楼梯问题,大家可以转化一下,并且发现一下爬楼梯问题的规律。

爬楼梯问题,基本上题目的状态只有两个,并且是固定的(不排除有变形的爬楼梯题目),递推的过程都是从小到大递推的。

好了,看看这道题,我们对照一下,首先,这里有两种操作,就是对应的两种固定的状态,我们可以通过这两个状态操作把字符串构造出来,再然后,我们这个字符串也是需要从小字符串推到大字符串的,所以这一点也和我们的结论符合,这就是一道变了题目的爬楼梯。

这里的递推关系就不多说了,dpi就代表的是构造长度为i的字符串有多少种方案的含义。

其他的步骤,也就是我们所给的zero,one,就代表着每次爬多少楼梯,low到high是我们需要统计的。

注意:在我们进行递推的时候,千万要注意,在循环的时候不要把i最开始初始化为low,因为这里的low并一定是从1开始递推的,而我们的dp数组是需要依次递推过来的,这一点需要注意;

在统计个数的时候,我们需要从low遍历到high这段距离,这一点是题目要求,不要忘记。

还有,在我们爬楼梯的过程中,变量是不明确的,也就是不知道数值是如何的,我们需要有一个if else判断语句,不然只会显示溢出,出现错误。

复制代码
class Solution {
    public int countGoodStrings(int low, int high, int zero, int one) {
        int []dp=new int[100010];
        dp[0]=1;
        for(int i=1;i<=high;i++){
            if(i>=zero&&i>=one)
            dp[i]=(dp[i-zero]+dp[i-one])%1000000007;
            else if(i>=zero&&i<one)
            dp[i]=dp[i-zero];
            else if(i<zero&&i>=one)
            dp[i]=dp[i-one];
        }
        int ans=0;
        for(int i=low;i<=high;i++)
        ans=(ans+dp[i])%1000000007;
        return ans;
    }
}
相关推荐
Run_Teenage6 小时前
算法:树的重心、树的直径
算法
专注仿真6 小时前
高代价计算后置:探测、交战、毁伤三条链路的统一设计哲学
算法·探测·毁伤
xie0510_6 小时前
Any类简要实现
开发语言·c++·算法
Sam_Deep_Thinking6 小时前
CountDownLatch实现原理
java·后端·面试·程序员
小狼Solar6 小时前
SAP MDG 功能范围说明(基于S/4HANA 2025)
java·开发语言
范中勤6 小时前
Python 与 Java:模块、包、对象、反射核心差异总结
java·python·面试·反射·元类
ab1237686 小时前
Spring Integration 完整笔记 + 和 spring-integration-mqtt、Paho、EMQX 的关系
java·笔记·spring
在所不辞兄6 小时前
为什么PINN非常适合求解有限元模型
人工智能·深度学习·神经网络·算法·机器学习
小蜗牛狂飙记6 小时前
java环境一键配置和切换的ui工具
java
逆光的July6 小时前
可靠消息投递与消费的工程设计:Outbox、幂等、死信兜底
java